﻿
using System;

Person p1 = new(new Name("Anders", "Hejlsberg"), 60);
Person p2 = new(new Name("Kevin", "Arnold"), 15);
Person p3 = new(new Name("Frank", "Arnold"), 15);
Person p4 = new(null, 18);

Person[] people = new Person[] { p1, p2, p3, p4 };

foreach (Person p in people)
{
    if (p is { Age: <= 20 } young)
    {
        Console.WriteLine($"{nameof(young)}: {young}");
    }

    if (p is { Name: { LastName: "Arnold" } } arnold)
    {
        Console.WriteLine(arnold);
    }

    // if (p is { Name.LastName: "Arnold" } arnold)
    // {
    //     Console.WriteLine(arnold);
    // }

    if (p is { Name: null })
    {
        Console.WriteLine("p.Name is null");
    }

    if (p is { Name: { } })
    {
        Console.WriteLine("p.Name is not null");
    }
}

record Name(string Firstname, string LastName);

record Person(Name Name, int Age);



namespace System.Runtime.CompilerServices
{
    public class IsExternalInit
    {
    }
}